create sequence IF NOT EXISTS hibernate_sequence start 1 increment 1;
create table IF NOT EXISTS capability
(
    id       int8        not null,
    config   jsonb,
    type     varchar(25) not null,
    group_id uuid,
    primary key (id)
);
create table IF NOT EXISTS group_member
(
    id                 int8         not null,
    external_member_id varchar(128) not null,
    group_id           uuid         not null,
    manual             boolean      not null,
    search_criteria_id uuid,
    primary key (id)
);
create table IF NOT EXISTS groups
(
    id                 uuid                     not null,
    content_type       varchar(25)              not null,
    created_on         TIMESTAMP WITH TIME ZONE not null,
    description        varchar(255),
    discovered         boolean                  not null,
    discovered_source  varchar(255),
    modified_on        TIMESTAMP WITH TIME ZONE not null,
    name               varchar(255)             not null,
    org_key            varchar(50)              not null,
    search_criteria    jsonb,
    search_criteria_id uuid,
    status             varchar(25)              not null,
    primary key (id)
);
create table IF NOT EXISTS queue_message
(
    id         uuid                     not null,
    created_on TIMESTAMP WITH TIME ZONE not null,
    primary key (id)
);
create index IF NOT EXISTS IX_groupMember_groupId on group_member (group_id);
create index IF NOT EXISTS IX_groupMember_externalMemberId on group_member (external_member_id);

create index IF NOT EXISTS IX_groups_orgKey on groups (org_key);

alter table capability
    drop constraint IF EXISTS FK_capability_groups_groupId;
alter table capability
    add constraint FK_capability_groups_groupId foreign key (group_id) references groups;

alter table group_member
    drop constraint IF EXISTS UniqueGroupIdAndExternalMemberId;
alter table group_member
    add constraint UniqueGroupIdAndExternalMemberId unique (group_id, external_member_id, manual);

alter table groups
    drop constraint IF EXISTS UniqueGroupNameAndOrgKey;
alter table groups
    add constraint UniqueGroupNameAndOrgKey unique (org_key, name)